<template>
	<div class="shipping-module">
		<div class="shipping-module__message">
			<span class="shipping-module__message-icon">
				<IconShipping/>
			</span>

			<span class="shipping-module__message-text" v-if="isEligibleForFreeShipping">
				{{ 'sections.cart.free_shipping.qualified' | t }}
			</span>

			<span class="shipping-module__message-text" v-else>
				{{ 'sections.cart.free_shipping.amount_left' | t({ amount: freeShippingAmountLeftMoney }) }}
			</span>
		</div>

		<div class="shipping-module__bar">
			<span class="shipping-module__bar-track"></span>

			<span
				class="shipping-module__bar-indicator"
				:style="{
					width: `${progressIndicatorWidth}%`
				}"
			></span>
		</div>
	</div>
</template>

<script>
import mapFilters from "../../filters/mapFilters";

import IconShipping from "./../../../../icons/icon-shipping.svg";

export default {
	name: 'ShippingModule',
	props: {
		cartTotal: {
			type: Number,
			required: true
		},
		freeShippingThreshold: {
			type: Number,
			required: true
		}
	},
	computed: {
		freeShippingAmountLeft() {
			return this.freeShippingThreshold - this.cartTotal;
		},
		freeShippingAmountLeftMoney() {
			return this.money(this.freeShippingAmountLeft);
		},
		isEligibleForFreeShipping() {
			return this.freeShippingAmountLeft <= 0;
		},
		progressIndicatorWidth() {
			const threshold = this.freeShippingThreshold;
			const total = this.cartTotal;

			const value = (total / threshold) < 1 ? (total / threshold) : 1;

			return value * 100;
		}
	},
	methods: {
		...mapFilters([
			'money'
		])
	},
	components: {
		IconShipping
	}
}
</script>
